Attribute VB_Name = "modMain"
Option Explicit

Private Declare Sub PokeLng Lib "kernel32.dll" Alias "RtlMoveMemory" (ByVal Addr As Long, ByRef Value As Long, Optional ByVal Bytes As Long = 4&)

Private Sub Main()
    Call MsgBox("Daten werden sortiert, dies kann ein bisschen Zeit beanspruchen!")
    Call Randomize
    Dim Master(0 To 499) As String
    Dim Data(0 To 499) As String
    Call Shuffle(Master)
    Dim i As Integer
    For i = 0 To 499
        Data(i) = Master(i)
    Next i
    Call BubbleSortStr(Data, LBound(Data), UBound(Data))
    For i = 0 To 499
        Data(i) = Master(i)
    Next i
    Call QuickSortStr(Data, 0, UBound(Data))
    Call MsgBox("Fertig ;-)")
End Sub

'
' Bubblesort zum alphabetischen Sortieren von Strings.
'
Private Sub BubbleSortStr(ByRef Data() As String, ByVal Lb As Long, ByVal Ub As Long)
    Dim p As Long, i As Long
    Do While Ub > Lb
        p = Lb
        For i = Lb To Ub - 1
            If Data(i) > Data(i + 1) Then
                Call SwapStrings(Data(i + 1), Data(i))
                p = i
            End If
        Next i
        Ub = p
    Loop
End Sub

'
' Einfache Implementierung von Quicksort. Unter VB knnen Strings mit dem Operator > bzw. hnlichen
' Operatoren auf ihre alphabetische Reihenfolge verglichen werden. Daher unterscheidet sich der
' Code nicht von dem zum Vergleich von Zahlen; abgesehen davon, dass wir hier nur mit String-Variablen
' arbeiten. Man knnte den Code auch so erweitern, dass ein binrvergleich durchgefhrt wird.
'
Private Sub QuickSortStr(ByRef Data() As String, ByVal l As Long, ByVal r As Long)
    Dim x As String
    Dim i As Long, j As Long
    i = l
    j = r
    x = Data((l + r) / 2)
    Do
        Do While (Data(i) < x)
            i = i + 1
        Loop
        
        Do While (Data(j) > x)
            j = j - 1
        Loop
        If i <= j Then
            Call SwapStrings(Data(i), Data(j))
            i = i + 1
            j = j - 1
        End If
    Loop Until (i > j)
    If l < j Then Call QuickSortStr(Data, l, j)
    If i < r Then Call QuickSortStr(Data, i, r)
End Sub

'
' Vertauschen zweier Strings, ohne die Daten zu kopieren. Es werden nur die Zeiger auf die Daten-Teile
' der Strings vertauscht.
'
Private Sub SwapStrings(ByRef s As String, ByRef t As String)
    Dim p As Long
    p = StrPtr(s)
    Call PokeLng(VarPtr(s), StrPtr(t))
    Call PokeLng(VarPtr(t), p)
End Sub

'
' Erstellt zufllig "gemischte" Zeichenfolgen.
'
Private Sub Shuffle(ByRef Data() As String)
    Dim i As Integer, j As Integer, t As String
    For i = 0 To UBound(Data)
        t = ""
        For j = 0 To 8
            t = t & Chr$(Rnd * 25 + 65)
        Next j
        Data(i) = t
    Next i
End Sub
